#!/bin/sh

### Parameters
THEPEG_VERSION=1.9.2p1
GSL_VERSION=1.10
HEPMC_VERSION=2.06.09
LHAPDF_VERSION=6.1.4

[ ! "Darwin" = $(uname -s) ] && source /afs/cern.ch/sw/lcg/contrib/gcc/4.9.1/x86_64-slc6-gcc48-opt/bin/../setup.sh
### End parameters

scriptdir=$(cd "$(dirname -- "${BASH_SOURCE:-$0}")" && pwd)
LCGDIR=$(cd $scriptdir;pwd | awk -F'/MCGenerators' '{print $1}')
MCGEN=$LCGDIR/$(cd $scriptdir;pwd | awk -F"$LCGDIR" '{print $2}' | awk -F'/' '{print $2}')
PLATFORM=$(basename $scriptdir)

LHAPDF_HOME=$LCGDIR/lhapdfsets/$LHAPDF_VERSION
HEPMC_HOME=$LCGDIR/HepMC/$HEPMC_VERSION/$PLATFORM
THEPEG_HOME=$MCGEN/thepeg/$THEPEG_VERSION/$PLATFORM
GSL_HOME=$LCGDIR/GSL/$GSL_VERSION/$PLATFORM

export PATH=$THEPEG_HOME/bin:$PATH
export LD_LIBRARY_PATH=${THEPEG_HOME}/lib/ThePEG:${GSL_HOME}/lib:${HEPMC_HOME}/lib:${GSL_HOME}/lib:$LD_LIBRARY_PATH
export LHAPATH=$LHAPDF_HOME/share/PDFsets
[ "Darwin" = $(uname -s) ] && export DYLD_LIBRARY_PATH=$LD_LIBRARY_PATH
